//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39F89FA70335.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39F89FA70335.cm

//## begin module%39F89FA70335.cp preserve=no
//## end module%39F89FA70335.cp

//## Module: ResponseContainer%39F89FA70335; Package specification
//## Subsystem: XSModel::GlobalContainer%3E4293160205
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/GlobalContainer/ResponseContainer.h

#ifndef RESPONSECONTAINER_H
#define RESPONSECONTAINER_H 1

//## begin module%39F89FA70335.additionalIncludes preserve=no
//## end module%39F89FA70335.additionalIncludes

//## begin module%39F89FA70335.includes preserve=yes
#include <utility>
#include <XSUtil/Error/Error.h>
#include <set>
//## end module%39F89FA70335.includes

// Reference
#include <XSUtil/Utils/Reference.h>
// Response
#include <XSModel/Data/Detector/Response.h>
// RMF
#include <XSModel/Data/Detector/RMF.h>
// ResponseTypes
#include <XSModel/GlobalContainer/ResponseTypes.h>

class DummyResponse;

//## begin module%39F89FA70335.declarations preserve=no
//## end module%39F89FA70335.declarations

//## begin module%39F89FA70335.additionalDeclarations preserve=yes
class ResponseParam;
class Parameter;
//## end module%39F89FA70335.additionalDeclarations


//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    //## begin XSContainer%3E42929A0210.initialDeclarations preserve=yes
    //## end XSContainer%3E42929A0210.initialDeclarations

    //## begin XSContainer::ResponseContainer%376A5DA5E608.preface preserve=yes
    //## end XSContainer::ResponseContainer%376A5DA5E608.preface

    //## Class: ResponseContainer%376A5DA5E608; private
    //## Category: XSModel::GlobalContainer%3E42929A0210
    //## Subsystem: XSModel::GlobalContainer%3E4293160205
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%3A92F39703D7;RefCountPtr< RMF > { -> }
    //## Uses: <unnamed>%3A92F3CB0017;RMF { -> }
    //## Uses: <unnamed>%3ABA779C01EA;ResponseMap { -> }
    //## Uses: <unnamed>%3ABB6AB00326;DummyResponse { -> F}
    //## Uses: <unnamed>%3ABB6B840366;std::ostringstream { -> }

    class ResponseContainer 
    {
      //## begin XSContainer::ResponseContainer%376A5DA5E608.initialDeclarations preserve=yes
      //## end XSContainer::ResponseContainer%376A5DA5E608.initialDeclarations

      public:
        //## Class: IndexOffsetMap%49E63BB001F3
        //	Key = specNum, Value = parameter index offset
        //## Category: XSModel::GlobalContainer%3E42929A0210
        //## Subsystem: XSModel::GlobalContainer%3E4293160205
        //## Persistence: Transient
        //## Cardinality/Multiplicity: n



        typedef std::map<size_t,size_t> IndexOffsetMap;

        //## Constructors (specified)
          //## Operation: ResponseContainer%3E9C2D190182
          ResponseContainer (DummyResponse* dummy);

        //## Destructor (generated)
          ~ResponseContainer();


        //## Other Operations (specified)
          //## Operation: Instance%376A5F063B58; C++
          //	Additional Public Declarations
          static ResponseContainer* Instance (DummyResponse* dummy);

          //## Operation: addToList%39ECBCF6024F
          void addToList (const string& name, Response* newResponse);

          //## Operation: addToList%3A9D615702AD
          void addToList (const RefCountPtr<RMF>& newRMF);

          //## Operation: responseList%3ABB685D031B
          const Response* responseList (const string& name, size_t index) const;

          //## Operation: responseList%3ABB688400BB
          Response* responseList (const string& name, size_t index);

          //## Operation: numberOfResponses%3ABBCB990097
          size_t numberOfResponses () const;

          //## Operation: removeByToken%3AC217B603CD
          void removeByToken (const std::vector<Response*>& doomed, size_t sourceNum = 0);

          //## Operation: removeByToken%3ACB287D0018
          //## Exceptions: ()
          void removeByToken (const RefCountPtr<RMF>& doomed) throw ();

          //## Operation: swapResponses%3E70B2A0000B
          Response* swapResponses (Response* inResponse, Response* outResponse);

          //## Operation: clearGainParameters%414A047200CA
          void clearGainParameters ();

          //## Operation: adjustNumSources%49E4EFBA0237
          void adjustNumSources (size_t nSources);

          //## Operation: addToRespParContainer%49E78FCD009D
          //	Allow Response objects to enter all or a subset (for a
          //	future equivalent of addcomp) of their parameters into
          //	the global container.  startIdx is the 0-BASED position
          //	of the first parameter in the vector w/respect to the
          //	first parameter in the Response.  The vector arg itself
          //	would become obsolete if Response were to maintain its
          //	own vector<ResponseParam*>  as a data member as part of
          //	a future generalization of Response functions.
          void addToRespParContainer (const Response* resp, size_t startIdx, const std::vector<ResponseParam*>& respParams);

          //## Operation: removeFromRespParContainer%49E792DC0240
          //	Allow Response objects to remove all or a subset of
          //	their ResponseParams from the global container.  start
          //	Idx is the 0-BASED position of the first parameter to be
          //	removed w/respect to the first parameter in the
          //	Response.  nPars is the number of consecutively indexed
          //	parameters to be removed, beginning with startIdx.
          void removeFromRespParContainer (const Response* resp, size_t startIdx, size_t nPars);

          //## Operation: reportResponseParams%49FB131D0276
          void reportResponseParams () const;

          //## Operation: renumberSpectrum%4A0DD58C01FB
          //	This must be called when spectrum numbers change due to
          //	a delete with preserve xsData operation.  The Response
          //	Container will need to update the entries in its respPar
          //	IndexOffsets bookkeeping container.  All keys larger
          //	than start will be shifted DOWN by offset.
          void renumberSpectrum (const size_t start, const size_t offset);

        //## Get and Set Operations for Class Attributes (generated)

          //## Attribute: respParContainer%49E4ED5F0381
          //	A vector of vector to ResponseParam pointers.  Outer
          //	vector size should always equal DataContainer's num
          //	SourcesForSpectra, and will contain empty vectors for
          //	sources without response parameters.  Pointers will be
          //	placed in sequential order of parameter index numbers
          //	for each source.  The ResponseParam pointers are
          //	non-owning.
          const RespParContainer& respParContainer () const;

          //## Attribute: totalResponseParams%49ECD547037C
          size_t totalResponseParams () const;

        //## Get and Set Operations for Associations (generated)

          //## Association: XSModel::Data::Detector::<unnamed>%3A92F1FF015C
          //## Role: ResponseContainer::RMFmap%3A92F20103C4
          //## Qualifier: name%3A92F234025E; string
          const RMFMap& RMFmap () const;
          void RMFmap (const RMFMap& value);

          //## Association: XSModel::Data::Detector::<unnamed>%3ABA77BD01E2
          //## Role: ResponseContainer::responseList%3ABA77BE019D
          //## Qualifier: name%3ABA77D80307; string
          ResponseMap& responseList ();

      public:
        // Additional Public Declarations
          //## begin XSContainer::ResponseContainer%376A5DA5E608.public preserve=yes
          //## end XSContainer::ResponseContainer%376A5DA5E608.public

      protected:
        // Additional Protected Declarations
          //## begin XSContainer::ResponseContainer%376A5DA5E608.protected preserve=yes
          //## end XSContainer::ResponseContainer%376A5DA5E608.protected

      private:

        //## Other Operations (specified)
          //## Operation: responseList%3ABB697502A8
          void responseList (const string& name, Response* value);

          //## Operation: RMFmap%3ABB7E70005E
          void RMFmap (const string& name, const RefCountPtr<RMF>& rmf);

          //## Operation: internalFind%3BAF7BAD0093
          Response* internalFind (const string& name, size_t index) const;

          //## Operation: rerouteBrokenParLinks%49C2984A0189
          void rerouteBrokenParLinks (std::set<Parameter*>& doomedPars) const;

          //## Operation: reindexResponseParams%49E646B30033
          //	Reindex parameters due to insertion/deletion of nChanged
          //	parameters occuring at given source and spectrum.  All
          //	indices below this location should be unaffected.  iResp
          //	Start is the position in the ResponseParam* vector of
          //	the first parameter in the affected Response.  Positive n
          //	Changed indicates insertion took place, negative
          //	indicates deletion.
          void reindexResponseParams (size_t sourceNum, size_t specNum, size_t iRespStart, int nChanged);

        // Additional Private Declarations
          //## begin XSContainer::ResponseContainer%376A5DA5E608.private preserve=yes
          //## end XSContainer::ResponseContainer%376A5DA5E608.private

      private: //## implementation
        // Data Members for Class Attributes

          //## Attribute: instance%376A5F0561A8
          //## begin XSContainer::ResponseContainer::instance%376A5F0561A8.attr preserve=no  private: static ResponseContainer* {U} 0
          static ResponseContainer* s_instance;
          //## end XSContainer::ResponseContainer::instance%376A5F0561A8.attr

          //## begin XSContainer::ResponseContainer::respParContainer%49E4ED5F0381.attr preserve=no  public: RespParContainer {U} 
          RespParContainer m_respParContainer;
          //## end XSContainer::ResponseContainer::respParContainer%49E4ED5F0381.attr

          //## Attribute: respParIndexOffsets%49E63C840228
          //	Private bookkeeping container needed to determine
          //	starting ResponseParam index value for a given spectrum
          //	for each source.  Outer vector corresponds to sources
          //	and should always be sized to DataContainer's numSources
          //	ForSpectra.  Each map contains entries of (spec
          //	Num,offset) pairs and may be empty.  Pairs should only
          //	be entered for spectra that actually have response
          //	parameters at a given source.
          //## begin XSContainer::ResponseContainer::respParIndexOffsets%49E63C840228.attr preserve=no  private: std::vector<IndexOffsetMap> {U} 
          std::vector<IndexOffsetMap> m_respParIndexOffsets;
          //## end XSContainer::ResponseContainer::respParIndexOffsets%49E63C840228.attr

          //## begin XSContainer::ResponseContainer::totalResponseParams%49ECD547037C.attr preserve=no  public: size_t {U} 
          size_t m_totalResponseParams;
          //## end XSContainer::ResponseContainer::totalResponseParams%49ECD547037C.attr

        // Data Members for Associations

          //## Association: XSModel::Data::Detector::<unnamed>%3A92F1FF015C
          //## begin XSContainer::ResponseContainer::RMFmap%3A92F20103C4.role preserve=no  public: RefCountPtr< RMF > { -> 1..nRHN}
          RMFMap m_RMFmap;
          //## end XSContainer::ResponseContainer::RMFmap%3A92F20103C4.role

          //## Association: XSModel::Data::Detector::<unnamed>%3ABA77BD01E2
          //## begin XSContainer::ResponseContainer::responseList%3ABA77BE019D.role preserve=no  public: Response { -> 1..nRHgN}
          ResponseMap m_responseList;
          //## end XSContainer::ResponseContainer::responseList%3ABA77BE019D.role

        // Additional Implementation Declarations
          //## begin XSContainer::ResponseContainer%376A5DA5E608.implementation preserve=yes
          //## end XSContainer::ResponseContainer%376A5DA5E608.implementation

    };

    //## begin XSContainer::ResponseContainer%376A5DA5E608.postscript preserve=yes
    //## end XSContainer::ResponseContainer%376A5DA5E608.postscript

    // Class XSContainer::ResponseContainer 

    //## Get and Set Operations for Class Attributes (inline)

    inline const RespParContainer& ResponseContainer::respParContainer () const
    {
      //## begin XSContainer::ResponseContainer::respParContainer%49E4ED5F0381.get preserve=no
      return m_respParContainer;
      //## end XSContainer::ResponseContainer::respParContainer%49E4ED5F0381.get
    }

    inline size_t ResponseContainer::totalResponseParams () const
    {
      //## begin XSContainer::ResponseContainer::totalResponseParams%49ECD547037C.get preserve=no
      return m_totalResponseParams;
      //## end XSContainer::ResponseContainer::totalResponseParams%49ECD547037C.get
    }

    //## Get and Set Operations for Associations (inline)

    inline const RMFMap& ResponseContainer::RMFmap () const
    {
      //## begin XSContainer::ResponseContainer::RMFmap%3A92F20103C4.get preserve=no
      return m_RMFmap;
      //## end XSContainer::ResponseContainer::RMFmap%3A92F20103C4.get
    }

    inline void ResponseContainer::RMFmap (const RMFMap& value)
    {
      //## begin XSContainer::ResponseContainer::RMFmap%3A92F20103C4.set preserve=no
      m_RMFmap = value;
      //## end XSContainer::ResponseContainer::RMFmap%3A92F20103C4.set
    }

} // namespace XSContainer

//## begin module%39F89FA70335.epilog preserve=yes
//## end module%39F89FA70335.epilog


#endif
